
CoCoALib - Feature #1249

principal ideal has a Gbasis

01 Mar 2019 17:34 - John Abbott

Status: Closed Start date: 01 Mar 2019

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: Improving Estimated time: 3.01 hours

Target version: CoCoALib-0.99650 November 2019 Spent time: 2.65 hours

Description

If and ideal has a single (non-zero) generator then that generator is automatically a Gbasis.

CoCoALib does not currently recognize this.

Discuss/fix.

Related issues:

Related to CoCoA-5 - Support #1240: John's visit Feb 2019 Closed 08 Feb 2019

Related to CoCoALib - Design #1255: Ideals with trivial GBasis New 11 Mar 2019

Related to CoCoALib - Bug #1256: RingID: different values in test-output on d... Closed 15 Mar 2019

History

#1 - 01 Mar 2019 17:34 - John Abbott

- Related to Support #1240: John's visit Feb 2019 added

#2 - 06 Mar 2019 17:17 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

Also if the gens happen to have coprime LTs wrt to current ordering then they are a GBasis.  Might be useful to have a function which checks if the

gens are "obviously" a GBasis (without computing anything)?

Also it could be worth computing a GBasis with a low timeout...

---> moved to #1255

#3 - 11 Mar 2019 18:53 - John Abbott

Here are some more minor points (after speaking to Anna on the phone):

Anna was concerned about potential cost if there are many gens;

if there are more (non-zero) gens than indets then the LTs cannot be coprime;

when scanning through the list of LTs, if the number of unseen indets is less than the number of remaining (non-zero) gens then they cannot all

be pairwise coprime.

---> moved to #1255

#4 - 11 Mar 2019 19:17 - Anna Maria Bigatti

- Related to Design #1255: Ideals with trivial GBasis added
#5 - 11 Mar 2019 19:18 - Anna Maria Bigatti

- % Done changed from 10 to 80

Done and partly tested.

#6 - 28 Mar 2019 16:36 - John Abbott

- Related to Bug #1256: RingID: different values in test-output on different platforms added

#7 - 28 Mar 2019 16:39 - John Abbott

Having seen in the code that computing a GBasis over QQ implies creating a new ring (with coeffs in ZZ), encourages me to push for avoiding

computing a GBasis if the gens are already "obviously" a GBasis (e.g. LPPs are coprime).

One could also use a heuristic: reduce the gens mod p (for several primes), and then check that all S-pairs reduce to 0 mod p (probably with a time

limit).  Maybe this is too complicated while also being uncertain...

#8 - 01 Oct 2019 11:57 - John Abbott

- Assignee set to Anna Maria Bigatti

Has this already been done?

I think what Anna showed me in Genova, indicated that it has been done.  If so, we can close!

#9 - 01 Oct 2019 15:42 - Anna Maria Bigatti

- Status changed from In Progress to Closed

- % Done changed from 80 to 100

#10 - 10 Oct 2019 19:12 - Anna Maria Bigatti

- Estimated time set to 3.01 h
